package codeOfValue;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static codeOfValue.StagedDataTypes.*;

public class Compiler extends util.ACompiler<Exp,ValueFun> {
    public static void main(String[] args) throws IOException { new Compiler().run(args); }

    public static final parser.LintParser<Exp> PARSER = new parser.LintParser<Exp>(Exp.class)
        .addSubParser(new parser.LintParser<Value>(Value.class));
    
    public Exp parse(String source) {
        return PARSER.parse(source);
    }
    
    public Code<ValueFun> getFunction(final Exp funBody) {
        return <| (ValueFun) new ValueFun() {
            public Value apply(final Value param) {
                return `(bindParameter(funBody, <| param|>));
            }
        } |>;
    }
}
