package gadts;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static gadts.StagedDataTypes.*;

public class Compiler extends util.ACompiler<Exp,Fun<Value,Value>> {
    public static void main(String[] args) throws IOException { new Compiler().run(args); }

    public static final parser.LintParser<Exp> PARSER = new parser.LintParser<Exp>(Exp.class)
        .addSubParser(new parser.LintParser<Value>(Value.class));
    
    public Exp parse(String source) {
        return PARSER.parse(source);
    }
    
    public Code<Fun<Value,Value>> getFunction(final Exp funBody) {
        final ProgramIR pir = bindFunction("m", "f", "n", funBody);
        return <| (Fun<Value,Value>) new Fun<Value,Value>() {
            public Value apply (Value input) {
                return `(evalFunction("m", <| input |>, pir));
            }
        } |>;
    }
}
