package gadts;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static gadts.ParLoops.*;

public class Interpreter extends util.AInterpreter<Exp,Value,Value> {
    public static void main(String[] args) throws IOException { new Interpreter().run(args); }
    
    public Value parseArgument(String arg) {
        try {
            Integer i = new Integer(arg);
            return new IntValue(i);
        }
        catch(NumberFormatException nfe) {
            return new BooleanValue(new Boolean(arg));
        }
    }
    
    public static final parser.LintParser<Exp> PARSER = new parser.LintParser<Exp>(Exp.class)
        .addSubParser(new parser.LintParser<Value>(Value.class));
    
    public Exp parse(String source) {
        return PARSER.parse(source);
    }
    
    public Value interpret(Exp functionBody, Value arg) {
        return new Program(new App("f", new Val(arg)),
                           new Declaration("f", "n", functionBody)).peval(env0, fenv0);
    }
}
