package gadts;

import edu.rice.cs.mint.runtime.Code;
import java.util.concurrent.*;
import java.util.*;

public class Test {

    public static interface Fun<T,U> {
        public U apply (T input);
    }

    public static interface FunMaker<T,U> {
        public separable Code<Fun<T,U>> eval ();
    }

    public static class IdFunMaker<T> implements FunMaker<T,T> {
        Class<T> t;
        IdFunMaker (Class<T> t) { this.t = t; }
        public separable Code<Fun<T,T>> eval () {
            return makeIdCode (t);
        }
    }

    public static abstract class Program {
        public separable abstract Code<Integer> eval ();
    }

    public static class ProgramBody extends Program {
        public int body;
        ProgramBody (int body) { this.body = body; }
        public separable Code<Integer> eval () {
            final int i = body;
            return <| i |>;
        }
    }

    public static class ProgramBinding<T,U> extends Program {
        FunMaker<T,U> maker;
        Class<T> t;
        Class<U> u;
        Program body;

        ProgramBinding (FunMaker<T,U> maker, Class<T> t,
                        Class<U> u, Program body) {
            this.maker = maker; this.t = t; this.u = u; this.body = body;
        }
        public separable Code<Integer> eval () {
            return eval_helper (maker, body, t, u);
        }
        public static separable <T2,U2> Code<Integer> eval_helper (FunMaker<T2,U2> maker2,
                                                                   Program body2,
                                                                   final Class<T2> t,
                                                                   final Class<U2> u) {
            ///return <| let Fun<T2,U2> f = `(maker2.eval ()); `(body.eval ()) |>;
            return <| `(body2.eval()) |>;
        }
    }

    public static separable <T> Code<Fun<T,T>> makeIdCode (final Class<T> t) {
        return <| (Fun<T,T>) new Fun<T,T> () { public T apply (T in) { return in; } } |>;
    }

    public static separable <T> Code<Integer> nLets (int n, final Class<T> t) {
        if (n == 0) {
            return <| 1 |>;
        } else {
            return <| let Fun<T,T> f = `(makeIdCode (t)); `(nLets (n - 1, t)) |>;
        }
    }

    public static void main(String[] args) {
        nLets (2, Integer.class).run ();

        Program p = new ProgramBinding<Integer,Integer>
            (new IdFunMaker<Integer> (Integer.class), Integer.class, Integer.class,
             new ProgramBinding<Boolean,Boolean>
             (new IdFunMaker<Boolean> (Boolean.class), Boolean.class, Boolean.class,
              new ProgramBody (5)));
    }
}
