package util;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

public abstract class AInterpreter<E,A,R> {
    public void run(String[] args) throws IOException {
        if (args.length<2) { System.err.println(this.getClass().getName()+" <file> <arg>"); return; }
        File f = new File(args[0]);
        if (!f.exists()) { System.err.println("Input file "+f+" does not exist."); return; }
        A arg = null;
        try {
            arg = parseArgument(args[1]);
        }
        catch(Throwable t) {
            System.err.println("The 2nd argument was not formatted correctly: "+args[1]); return;
        }
        
        String source = IO.readFile(f);
        final E functionBody = parse(source);
        System.out.println(interpret(functionBody, arg));
    }
    
    public abstract A parseArgument(String arg);    
    public abstract E parse(String source);
    public abstract R interpret(E functionBody, A arg);
}
