package util;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

public abstract class ARunner<F,A,R> {
    public void run(String[] args) throws IOException {
        if (args.length<2) { System.err.println(this.getClass().getName()+" <file> <int>"); return; }
        File f = new File(args[0]);
        if (!f.exists()) { System.err.println("Input file "+f+" does not exist."); return; }
        A arg = null;
        try {
            arg = parseArgument(args[1]);
        }
        catch(Throwable t) {
            System.err.println("The 2nd argument was not formatted correctly: "+args[1]); return;
        }

        F sFun = MintSerializer.load(f);
        System.out.println(execute(sFun, arg));
    }
    
    public abstract A parseArgument(String arg);    
    public abstract R execute(F functionBody, A arg);
}
